#include <iostream>
#include <stdlib.h>
#include <cstring>
using namespace std;

class Record{
private:
	int product[1000];
	int num;	//strlen(product)
	int dist_num;	//dist number

public:
	Record(){
		for (int i=0;i<100;i++){
			product[i]=0;
		}
		num=0;
		dist_num = 0;
	}
	void add(int pid){
		if (num == 0){
			product[num]=pid;
			dist_num++;
			num++;
			return;
		}
		for (int i=0;i<num;i++){
			if (product[i]==pid){
				num++;
				return;
			}
		}
		product[num] = pid;
		dist_num ++;
		num++;
		return;
	}
	int getTotalNum(){
		return num;
	}
	int getDistNum(){
		return dist_num;
	}
};

class Trans{
private:
	int year;
	int month;
	int day;
	int id;
	char cat;
public:
	Trans(){
		year=0;
		month=0;
		day=0;
		id=0;
		cat=0;
	}
	void setTrans(int y,int m,int d, int i, char c){
		year=y;
		month=m;
		day=d;
		id=i;
		cat=c;
	}
	int getId(){
		return id;
	}
	int getYear(){
		return year;
	}
	int getMonth(){
		return month;
	}
	char getName(){
		return cat;
	}


};

int main(){
	int n = 0,year = 0,month = 0,day = 0,id = 0;
	char cat = 0;
	int item_num=0;
	cin >> n;
	Trans* list[1000]={0};

	//input
	for (int i=0;i<n;i++){
		cin >> year;
		cin >> month;
		cin >> day;
		cin >> id;
		cin >> cat;
		list[i]=new Trans;
		list[i]->setTrans(year,month,day,id,cat);
		item_num = i+1;
	}

	
	char input[10];
	cin.ignore(1000000,'\n');	//clear the buffer
	cin.getline(input,10);	//yyyy-mm
	char delim[]="-";

	char* ptr = strtok(input,delim);
	year = atoi(ptr);
	ptr = strtok(NULL,delim);
	month = atoi(ptr);
	Record r_list[26];
	for (int i=0;i<item_num;i++){
		if (list[i]->getYear() == year && list[i]->getMonth() == month){
			//add only the matched ones
			int index = list[i]->getName() - 'A';
			r_list[index].add(list[i]->getId());
		}
	}
	int max=0;
	int min_dist = 200;
	int max_index=0;
	for (int i=0;i<26;i++){
		if (max < r_list[i].getTotalNum()){
			max =r_list[i].getTotalNum();
			max_index = i;
			min_dist = r_list[i].getDistNum();
		}
		else if (max == r_list[i].getTotalNum()){
			if (min_dist > r_list[i].getDistNum()){
				max_index = i;
				max =r_list[i].getTotalNum();
				min_dist = r_list[i].getDistNum();
			}
		}
	}

	char output = static_cast<char>(max_index)+'A';
	cout << output <<" "<< r_list[max_index].getTotalNum() << " "<<r_list[max_index].getDistNum();

}